



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>elasticsearch系列（一） 术语</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">elasticsearch系列（一） 术语</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 04:51:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>elasticsearch（以下简称es）是一款开源的搜索引擎，基于apach lucene。最近在做nlp的时候顺便研究一下。</p>
<p>下面是官方列举的术语解释</p>
<h2>Near Realtime</h2>
<p>接近实时的查询，通常情况下，延迟在1s以内</p>
<h2>Cluster</h2>
<p>一个集群由1个或者多个节点组成，这些节点提供整个数据和索引，性能来源于每个节点。一个集群有一个唯一的名字，默认为“elasticsearch”，</p>
<h2>Node</h2>
<p>一个node启动的时候分配一个唯一的id（UUID），自动会加入名为“elasticsearch”的cluster，前提是网络没有问题，一个node只能加入一个集群。</p>
<h2>Index</h2>
<p>一个index是一些有相似特征的documents集合，比如有一个顾客类的index，一个生产类的index，有一个订单类的index。index必须都是小写的</p>
<h2>Type</h2>
<p>一个index可以定义出多个type，一个type是一个逻辑的类别或者分区，并且其语义完全取决于自己，一般而言一个type定义了包含多个fields的documents。</p>
<h2>Document</h2>
<p>一个document是可以被索引信息的基础单元，尽管一个document在物理上是属于index的，但事实上，一个document必须被索引或者分配到一个index里的type。</p>
<h2>Shard&amp;Replicas</h2>
<p>一个index可以存储大量的数据，并且超过单节点的限制。例如，单个index可能含有几十亿个documents，占据了1TB的磁盘空间，这就可能导致单个node可能没有这么大的空间，或者在查询的时候会很慢。</p>
<p>为了解决这个问题，es给出了shard的概念，将一个index拆分成多个部分。创建的index就可以申明shard的数量，每个shard都是拥有完整和独立的index。</p>
<p><strong>Sharding的两个重要点：</strong></p>
<p>1.shard允许你对大量数据做横向切分</p>
<p>2.shard允许通过多个shards分布式并发的操作，从而提升性能和吞吐量</p>
<p>Shard是如何分布的以及多个它们的documents是如何被合并都由es管理，这些对使用者都是透明的。</p>
<p>关于容错，es通过replica来解决，replica是index下的shard的副本。</p>
<p><strong>Replicaing的两个重要点：</strong></p>
<p>1.提供了HA。需要提醒的是，replica和shard不应该在同一个node</p>
<p>2.搜索可以在所有的replica并发处理</p>
<p>你可以在创建的时候设置index的shard和replica数量，但是之后，你只能更改replica的数量，而不能更改shard的数量.</p>
<p>Es的默认配置为，5个shards和1个replica，如果你的cluster有两个及以上的node，则一共有10个shards（5 primary shards,5 replica shards）</p>
<h2>其他</h2>
<p>Es的一个shard就是lucene的index</p>
<h2>总结</h2>
<p>逻辑上，index、type、documents作为namespace的存在，可以充分表现Restful风格的接口</p>
<p>物理上，index可以看做是数据库中的库，通过shard（类似partition）做HA和高并发</p>
<h2>参考资料</h2>
<p>//es官方介绍</p>
<p><a href="https://www.elastic.co/guide/en/elasticsearch/reference/5.2/_basic_concepts.html" rel="external nofollow noreferrer">https://www.elastic.co/guide/en/elasticsearch/reference/5.2/_basic_concepts.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqljm309.html">vue2&sol;vuex2的那点坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3mvxq.html">【温故Delphi】GAEA用到Win32 API目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3dde8.html">nginx搭建笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwexg3q.html">7&period;3---直线是否相交（CC150）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd16k7q.html">PHP5中魔术方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71kykq.html">js轮播</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq17040q.html">linux-01Red Hat Enterprise Linux 7（RHEL7）配置静态IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13l108.html">linux的库文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/39re1y4q.html">livewriter写Blog 神秘失踪？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y76peq.html">2016年11月ACM&sol;ICPC亚洲区北京赛赛后总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwxw09.html">codeforce 605B&period; Lazy Student</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm63ke9.html">java基础入门-arraylist存储开销</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmevoq.html">转一篇NGINX&plus;UWSGI&plus;PYTHON&plus;DJANGO部署文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1lmeq.html">android 背景图片的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkrpw8.html">osg蝴蝶纹理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgyw078.html">Visual Studio Team Services 帐户管理操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4zv1q.html">Spring&plus;SpringMVC&plus;MyBatis深入学习及搭建&lpar;十&rpar;&mdash;&mdash;MyBatis逆向工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17je1q.html">《程序员的职业素养》【PDF】下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojoooeq.html">Windows 性能搜集【perfmon】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjp4zx8.html">SpringBoot-异常问题总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv10011q.html">关于Storm Stream grouping</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1rgwdq.html">Python 之 json 模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4znd4e9.html">wemall开源商城免费商城系统部分代码（内含代码地址）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gedzme8.html">Android：NavigationView 导航抽屉</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zn7y09.html">node插件http-proxy实现反向代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j0g6x8.html">深度剖析Spark分布式执行原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpoxx0q.html">【iOS】7&period;4 定位服务-&amp;gt&semi;2&period;1&period;3&period;1 定位 - 官方框架CoreLocation 功能1&colon;地理定位</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zojlznq.html">rgba兼容性处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkexm08.html">Ubuntu14&period;04下搜狗输入法的安装及配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzpgoe8.html">nmap安装过程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
